from matplotlib.widgets import Slider


class LogSlider(Slider):

    def __init__(self, *args, base=10., **kwargs):
        self.base = base
        super().__init__(*args, **kwargs)

    def _set_val(self, val, val2):
        xy = self.poly.xy
        if self.orientation == 'vertical':
            xy[1] = .25, val
            xy[2] = .75, val
            self._handle.set_ydata([val])
        else:
            xy[2] = val, .75
            xy[3] = val, .25
            self._handle.set_xdata([val])
        self.poly.xy = xy
        self.valtext.set_text(self._format(val2))  # Modified to display 10**val instead of val
        if self.drawon:
            self.ax.figure.canvas.draw_idle()
        self.val = val2
        if not self.eventson:
            return
        self._observers.process('changed', val2)

    def set_val(self, val):
        val2 = self.base**val
        return self._set_val(val, val2)


class LogSlider0(LogSlider):

    def __init__(self, ax, label, valmin, valmax, *args, valstep, **kwargs):
        if valstep is not None:
            valmin = valmin - valstep
        super().__init__(ax, label, valmin, valmax, *args, **kwargs)

    def set_val(self, val):
        val2 = 0. if val == self.valmin else self.base**val
        return self._set_val(val, val2)
